<?php
  $this->headScript()->appendFile('vendor/d3.min.js');
  $this->headScript()->appendFile('visual_facets.js');

  $visualFacetSet = $this->recommend->getPivotFacetSet();

  if (isset($visualFacetSet->children)) {
    $flarechildren = [];

    foreach ($visualFacetSet->children as $toplevelfacet) {
      $toplevelinfo = [];
      $toplevelchildren = [];
      $toplevelinfo['name'] = $toplevelfacet['value'];
      $toplevelinfo['field'] = $toplevelfacet['field'];
      $toplevelinfo['size'] = $toplevelfacet['count'];
      $pivot = $toplevelfacet['pivot'] ?? [];
      foreach ($pivot as $secondlevelfacet) {
        $secondlevelinfo = [];
        $secondlevelinfo['name'] = $secondlevelfacet['value'];
        $secondlevelinfo['size'] = $secondlevelfacet['count'];
        $secondlevelinfo['field'] = $secondlevelfacet['field'];
        $secondlevelinfo['parentfield'] = $toplevelinfo['field'];
        $secondlevelinfo['parentlevel'] = $toplevelinfo['name'];
        array_push($toplevelchildren, $secondlevelinfo);
      }
      $toplevelinfo['children'] = $toplevelchildren;
      array_push($flarechildren, $toplevelinfo);
    }

    $visualFacetSet->children = $flarechildren;
  }
?>

<?php if (isset($visualFacetSet)): ?>
  <?php
    $pivotData = json_encode($visualFacetSet);
    $translations = $this->jsTranslations()->getJSONFromArray(
        [
          'More Topics' => 'More Topics',
          'visual_facet_parent' => 'visual_facet_parent',
          'items' => 'items',
          'more_topics_unescaped' => 'more_topics',
          'on_topic_unescaped' => 'on_topic',
        ]
    );

    $script = <<<JS
        VuFind.addTranslations($translations);
        var pivotdata = $pivotData;
        jQuery(document).ready(function(data) {
          showVisualFacets(pivotdata);
        });
        JS;
  ?>
  <?=$this->inlineScript(\Laminas\View\Helper\HeadScript::SCRIPT, $script, 'SET');?>
<?php endif; ?>
